--2021.01.26 v1.00
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity sw_if is
    Port ( clk : in STD_LOGIC;
           reset : in STD_LOGIC;
           sw0_in : in STD_LOGIC;
           sw1_in : in STD_LOGIC;
           sw0_out : out STD_LOGIC;
           sw1_out : out STD_LOGIC);
end sw_if;
architecture Behavioral of sw_if is
component sw_correction is
    Port ( clk : in STD_LOGIC;
           reset : in STD_LOGIC;
           sw_in  : in STD_LOGIC; --XCb`
           check_sig  : in STD_LOGIC; --`^O^C~O
           sw_out : out STD_LOGIC);
end component;
  signal timing_cnt : STD_LOGIC_VECTOR(19 downto 0);
  signal check_sig : STD_LOGIC;
  signal sw0_value : STD_LOGIC; 
  signal sw1_value : STD_LOGIC; 
begin
--`^O@^C~O 
  process(clk,reset) begin
  if reset='1' then 
    timing_cnt <= X"00000";
  else
    if clk'event and clk='1' then 
        timing_cnt <= timing_cnt + X"00001";
    end if;
  end if;
  end process;

  check_sig <= '1' when timing_cnt = X"FFFFF" else '0';
--M̃^Xe[uΐA`^O
  u0 : sw_correction port map(
    clk => clk,
    reset => reset,
    sw_in => sw0_in,
    check_sig => check_sig,
    sw_out => sw0_value);
  u1 : sw_correction port map(
    clk => clk,
    reset => reset,
    sw_in => sw1_in,
    check_sig => check_sig,
    sw_out => sw1_value);
    
  sw0_out <= sw0_value;    
  sw1_out <= sw1_value;
    
end Behavioral;
