`timescale 1ns / 1ps
//2021.01.26 v1.00
module s7seg_ctrl(
    input [15:0] count,
    output [6:0] data0_7seg,
    output [6:0] data1_7seg,
    output [6:0] data2_7seg,
    output [6:0] data3_7seg
    );
    //16進数->7セグ表示パターン変換関数
    function [6:0] hex2seg(input [3:0] data);
      begin
        case(data)
          4'h0:hex2seg =7'b1000000;//0の表示パターン
          4'h1:hex2seg =7'b1111001;//1の表示パターン
          4'h2:hex2seg =7'b0100100;
          4'h3:hex2seg =7'b0110000;
          4'h4:hex2seg =7'b0011001;
          4'h5:hex2seg =7'b0010010;
          4'h6:hex2seg =7'b0000010;
          4'h7:hex2seg =7'b1111000;
          4'h8:hex2seg =7'b0000000;
          4'h9:hex2seg =7'b0011000;
          4'ha:hex2seg =7'b0001000;
          4'hb:hex2seg =7'b0000011;
          4'hc:hex2seg =7'b1000110;
          4'hd:hex2seg =7'b0100001;
          4'he:hex2seg =7'b0000110;
          4'hf:hex2seg =7'b0001110;
          default:hex2seg = 7'b1111111;
      endcase
    end
    endfunction
    //各桁の変換                
    assign data0_7seg = hex2seg(count[3:0]); 
    assign data1_7seg = hex2seg(count[7:4]);    
    assign data2_7seg = hex2seg(count[11:8]);    
    assign data3_7seg = hex2seg(count[15:12]);     
endmodule
