`timescale 1ns / 1ps
//2021.01.26 v1.00
module sw_if(
    input clk,
    input reset,
    input sw0_in,
    input sw1_in,
    output sw0_out,
    output sw1_out
    );
    
    reg [19:0] timing_cnt;
    wire check_sig;
    wire sw0_value;
    wire sw1_value;    
    //`^O@^C~O    
    always@(posedge clk,posedge reset)
      if (reset==1'b1)
        timing_cnt <= 20'd0;
      else
       timing_cnt <=  timing_cnt + 20'd1;
    assign check_sig = (timing_cnt==20'hFFFFF)?1'b1:1'b0;
    
    //M̃^Xe[uΐA`^O
    sw_correction u0(
      .clk(clk),
      .reset(reset),
      .sw_in(sw0_in),
      .check_sig(check_sig),
      .sw_out(sw0_value));
      
    sw_correction u1(
      .clk(clk),
      .reset(reset),
      .sw_in(sw1_in),
      .check_sig(check_sig),
      .sw_out(sw1_value));
      
    assign sw0_out = sw0_value;
    assign sw1_out = sw1_value;
       
endmodule
