`timescale 1ns / 1ps
//2021.01.26 v1.00
module d7seg_ctrl(
    input clk,
    input reset,
    input [15:0] count,
    output [3:0] keta,  //wM
    output [6:0] data_7seg //7ZO\f[^M
    );    
    reg [15:0] timing_cnt;//IJE^
    wire timing_sig;//ؑփ^C~O
    reg [1:0] keta_cnt;//JE^
    wire [3:0] sel_cnt;//\16i
    //16i>7ZO\p^[ϊ֐
    function [6:0] hex2seg(input [3:0] data);
	begin
	  case(data)
	    4'h0:hex2seg =7'b1000000;//0̕\p^[
		4'h1:hex2seg =7'b1111001;//1̕\p^[
		4'h2:hex2seg =7'b0100100;
		4'h3:hex2seg =7'b0110000;
		4'h4:hex2seg =7'b0011001;
		4'h5:hex2seg =7'b0010010;
		4'h6:hex2seg =7'b0000010;
		4'h7:hex2seg =7'b1111000;
		4'h8:hex2seg =7'b0000000;
		4'h9:hex2seg =7'b0011000;
		4'ha:hex2seg =7'b0001000;
		4'hb:hex2seg =7'b0000011;
		4'hc:hex2seg =7'b1000110;
		4'hd:hex2seg =7'b0100001;
		4'he:hex2seg =7'b0000110;
		4'hf:hex2seg =7'b0001110;
		default:hex2seg = 7'b1111111;
	  endcase
	end
	endfunction
  //IJE^	
  always@(posedge clk)
    if (reset==1'b1)
      timing_cnt <= 16'd0;
    else
     timing_cnt <=  timing_cnt + 16'd1;    
  assign timing_sig = (timing_cnt==16'hFFFF)?1'b1:1'b0;
  //IJE^
  always@(posedge clk)
    if (reset==1'b1)
      keta_cnt <= 2'd0;
    else
      if(timing_sig==1'b1)
        keta_cnt <=  keta_cnt + 2'd1;
      else
        keta_cnt <= keta_cnt;
   //f[^I       
   assign sel_cnt = (keta_cnt==2'd0)?count[3:0]:
                    (keta_cnt==2'd1)?count[7:4]:
                    (keta_cnt==2'd2)?count[11:8]:count[15:12];
   //16i->7ZO\p^[ϊ                 
   assign  data_7seg=hex2seg(sel_cnt);    
   //wMfR[_
   assign keta = (keta_cnt==2'd0)?4'b1110:
                 (keta_cnt==2'd1)?4'b1101:
                 (keta_cnt==2'd2)?4'b1011:4'b0111;
endmodule
